//+------------------------------------------------------------------+
//|                                            SignalTrader_v1.4.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <WebGet.mqh>
#include <stdlib.mqh>

//---- input parameters
extern string     ExpertName       = "SignalTrader_v1.4";

extern int        Magic            =  33333;
extern int        Slippage         =       6;

extern string     Main_Parameters  = " Trade Volume & Trade Method";
extern int        CalendarID       =      15; // Calendar's ID on calendar.forex-tsd.com  
extern string     FileName         ="USDJPYm5"; // Name of Signal's File
extern int        ReqPeriod        =       30; // Calendar Request period in min 
extern double     Lots             =     1; // Lot size
extern int        OrderDuration    =       0; // Order Duratiton Time in min (0 - not use duration)
extern int        ProcessTime      =       5; // Order processing Time in min
extern int        UseNewSigClose   =       1; // Use Order Close after new signal(0-off,1-on) 
extern int        UseEODClose      =       0; // Use EOD Close (0-off,1-on) 
extern int        SessionEnd       =      23; // Session End Time
extern int        FridayEnd        =      22; // Session End Time in Friday
extern int        OrdersNum        =       1; // Number of orders
extern int        UseExtSets       =       0; // Use External Settings for TP and IS (0-off,1-on)
extern int        UseOpposite      =       0; // Use Opposite Orders: 0-off,1-on
extern int        DelOpposite      =       0; // Switch of orders deleting: 0-off,1-on
extern double     TakeProfit       =      200; // Take Profit in pips       	
extern double     StopLoss         =      100; // Initial Stop in pips 
extern double     TrailingStop     =      45; // Trailing Stop in pips 
extern double     BreakEven        =      30; // Breakeven in pips  

extern string     rFilter          = " Rating Filter ";
extern int        UseRatingFilter  =       1;
extern int        MaxRating        =       3;
extern int        MinRating        =       2;  

extern string     MM_Parameters    = " MoneyManagement by L.Williams ";
extern bool       MM               =   true; //  Switch
extern double     MaxRisk          =    0.04; // Risk Factor
extern double     LossMax          =       0; // Maximum Loss by 1 Lot


datetime FinTime=0;
string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sSymbol[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
string   sActual[1000];        // Actual value
string   sForecast[1000];      // Forecast value
string   sPrevious[1000];      // Previous value
//string   sImpact[1000];
datetime dt[1000];
int      BEvent=0, EventNum, TriesNum=5;
string   CalendarName;
bool     fTime;
datetime prevTime,OpenTime=0,prevOpenTime=0;
int      totalPips=0, TimeZone = 0;
double   totalProfits=0;
int      TypeOrder;
double   OrderPrice,OrderSL,OrderTP;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   fTime = true;
   
//----
return(0);
}
  
// ---- Money Management
//---- Calculation of Position Volume
double MoneyManagement()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if ( MM )
   {
   vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   Print("Margin=",AccountFreeMargin()," r=",MaxRisk," lev=",AccountLeverage()," cont=",contract);
   }
   else
   vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol<lot_min) vol=lot_min;
   if(vol>lot_max) vol=lot_max;
//---
   return(vol);
}   

// ---- Trailing Stops
void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if ( BreakEven > TrailingStop && BEvent==0 )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+1*Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+1*Point,Digits);
			      BEvent=1;
			      }
			   }
			   else 			   
			   if( TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*Point,Digits);
			   
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop || OrderStopLoss() == 0) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits)) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if ( BreakEven > TrailingStop && BEvent==0)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/Point;
			      if( Gain >= BreakEven && OrderStopLoss()>=OrderOpenPrice()-1*Point) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-1*Point,Digits);
			      BEvent=-1;
			      }
			   }
			   else 
			   if( TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*Point,Digits);   
            
            if((NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) || OrderStopLoss() == 0) 
            {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits)) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}

// ---- Open Sell Orders
int SellOrdOpen(int ord,double price,double sl,double tp,int num) 
{		     
   int ticket = 0;
   int tr = 1;
      
   while ( ticket <= 0 && tr <= TriesNum)
   {
   ticket = OrderSend( Symbol(),ord,MoneyManagement(),
	                    NormalizeDouble(price , Digits),
	                    Slippage,
	                    NormalizeDouble(sl, Digits),
	                    NormalizeDouble(tp, Digits),
	                    ExpertName+" SELL:"+num,Magic,0,Red);
      
      if(ticket > 0) 
      {
      BEvent=0;   
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
         Print("SELL order opened : ", OrderOpenPrice());
      }
	   else 	
      if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError()>0)
      Print("SELL: OrderSend failed with error #",ErrorDescription(GetLastError()));
      }
   }   
   return(ticket);
}

// ---- Open Buy Orders
int BuyOrdOpen(int ord,double price,double sl,double tp,int num)
{		     
   int ticket = 0;
   int tr = 1;
      
   while ( ticket <= 0 && tr <= TriesNum)
   {
   ticket = OrderSend(Symbol(),ord,MoneyManagement(),
	                   NormalizeDouble(price , Digits),
	                   Slippage,
	                   NormalizeDouble(sl, Digits), 
	                   NormalizeDouble(tp, Digits),
	                   ExpertName+" BUY:"+num,Magic,0,Blue);
      
      if(ticket > 0) 
      {
      BEvent=0;
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
         Print("BUY order opened : ", OrderOpenPrice());
      
      }
      else 
	   if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError()>0)      
      Print("BUY : OrderSend failed with error #",ErrorDescription(GetLastError()));
      }
   }   
   return(ticket);
} 

// ---- Scan Trades

int ScanTrades(int ord,int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   int trd = 0;
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if ( ord != 0 )
   {
   if ( OrderType()==0 || OrderType()==2 || OrderType()==4 ) trd =  1;
   if ( OrderType()==1 || OrderType()==3 || OrderType()==5 ) trd =  2;      
   } else trd=0;
   
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
   if (mode == 1) type = OrderType()<=OP_SELL;   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
   if(OrderSymbol() == Symbol() && type && trd==ord && OrderMagicNumber() == Magic)  
   numords++;
   }
   return(numords);
}  

datetime FinishTime(int Duration)
{   
   int total = OrdersTotal();
   datetime ftime=0;
         
   for(int i=0; i<total; i++) 
   {        
   OrderSelect(i, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   ftime=OrderOpenTime()+ Duration*60;
   }
   return(ftime);
}

// Closing of Pending Orders      
void PendOrdDel(int mode)
{
   bool result = false;
   
   for (int i=0; i<OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)     
      {
         if((mode==0 || mode==1) && OrderType()==OP_BUYSTOP)
         {     
         result = OrderDelete(OrderTicket());
         if(!result) Print("BUY: OrderDelete failed with error #",GetLastError());
         }
         else
         if((mode==0 || mode==2) && OrderType()==OP_SELLSTOP)
         {     
         result = OrderDelete( OrderTicket() );  
         if(!result) Print("SELL: OrderDelete failed with error #",GetLastError());
         }
      }
   }
}    

//-----
void ReadCalendar(string fName)
{    
   int i, handle;
   bool rates=false;
   
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
   
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
      else
      if(handle>=1)
      {
      i=0;
         while(!FileIsEnding(handle))
         {
         sDate[i]=FileReadString(handle);          // Date
         sTime[i]=FileReadString(handle);          // Time
         sSymbol[i]=FileReadString(handle);      // Currency
         sDescription[i]=FileReadString(handle);   // Description
         sRating[i]=FileReadString(handle);        // Rating
         sActual[i]=FileReadString(handle);       
         sForecast[i]=FileReadString(handle);      
         sPrevious[i]=FileReadString(handle);      
        
            if (UseRatingFilter > 0)
            {
            int rating = StrToInteger(sRating[i]);
            rates = rating <= MaxRating && rating >= MinRating;
            if(!rates) continue;      
            }   
      
            if (Symbol() == sSymbol[i]) 
            {
            dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
       
            string info = i+"_"+TimeToStr(dt[i])+" "+sSymbol[i]+" "+" "+sDescription[i]+" "+sActual[i];
             //Print( info );
            }
         i++;
         }
      FileClose(handle);
      }
   EventNum = i;
   
return(0);
}


//---- Close of Orders

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<=total; i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      ntr=0; 
      while (ntr<5 && !IsTradeAllowed()) { ntr++; Sleep(5000); }
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

bool TimeToOpen()
{
   bool result = false;
   
   for (int i=0; i<=EventNum; i++)
   { 
   //if( sDescription[i] == "Buy" || sDescription[i] == "SELL") datetime OpenTime = TimeCurrent();
   //else 
   OpenTime = dt[i];
   //Print("OpTime=",TimeToStr(OpenTime));
      if((TimeCurrent()>= OpenTime && TimeCurrent() <= OpenTime+ProcessTime*60) && OpenTime > prevOpenTime)
      {
      //Print("OK: OpTime=",TimeToStr(OpenTime));
         if (sDescription[i] == "BuyStop") TypeOrder = OP_BUYSTOP; 
         else
         if (sDescription[i] == "SellStop") TypeOrder = OP_SELLSTOP; 
         else
         if (sDescription[i] == "BuyLimit") TypeOrder = OP_BUYLIMIT; 
         else
         if (sDescription[i] == "SellLimit") TypeOrder = OP_SELLLIMIT;
         else
         if (sDescription[i] == "Buy") TypeOrder = OP_BUY; 
         else
         if (sDescription[i] == "Sell") TypeOrder = OP_SELL;
         else
         TypeOrder = -1;
      
      if ( TypeOrder>=2 ) OrderPrice = StrToDouble(sActual[i]); 
      if ( sSymbol[i]!="" && Symbol() == sSymbol[i]) result=true; 
         
         if ( UseExtSets > 0) 
         {
         OrderSL = StrToDouble(sForecast[i]); 
         OrderTP = StrToDouble(sPrevious[i]);
         }  
         else {OrderSL = 0; OrderTP = 0;}  
         
      //Print("i=",i, " price=",OrderPrice," Sym=",sSymbol[i]," res=",result);  
      break;
      }
   }
   return(result);
}

string ForexTSD_Calendar()
{
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>9) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   if (TimeDay(StartWeek)>9) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = FileName+"_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}

void ChartComment()
{
   
   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   TotalProfit();    
     
   sComment = sp;
   sComment = sComment+"ExpertName : "+ExpertName+NL;
   
   if(TimeZone >= 0)
   sComment = sComment+"Broker\'s Time Zone : GMT + " + TimeZone + NL;
   else
   sComment = sComment+"Broker\'s Time Zone : GMT - " + MathAbs(TimeZone) + NL;
   
   sComment = sComment+"Orders: Open= "+ScanTrades(0,1)+" Pending= "+ScanTrades(0,2)+" All= "+ScanTrades(0,0)+NL;
   sComment = sComment+"Current Profit(pips)= " + totalPips + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToStr(totalProfits,2) + NL; 
    
   Comment(sComment);
}      

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic && OrderSymbol() == Symbol()) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(Symbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(Symbol(),MODE_POINT));
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/MarketInfo(Symbol(),MODE_POINT));
            totalProfits += OrderProfit();
            break;
         }
      }            
	}
}               
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
 
//----
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(Bars < 1) {Print("Not enough bars for this strategy");return(0);}
   
   if(AccountFreeMargin()<(1000*Lots)){
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);}
//---- 
   datetime cTime = iTime(NULL,ReqPeriod,0);
   
   if (fTime || (TimeCurrent() >= cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;
   
   
   CalendarName = ForexTSD_Calendar();  
      
      if(CalendarName != "")
      {   
      ReadCalendar(CalendarName);
      fTime = false;
      prevTime = cTime;
      }
      else 
      {
      //Print("Attention! Wrong Calendar:",CalendarName,"time=",TimeToStr(TimeCurrent())); 
      return(0);
      }
   
   }
   
   ChartComment();
   
   if (ScanTrades(0,0) > 0)
   {
      if (DelOpposite > 0)
      {
         if (ScanTrades(1,1) > 0 && ScanTrades(2,2) > 0) PendOrdDel(2);
         if (ScanTrades(2,1) > 0 && ScanTrades(1,2) > 0) PendOrdDel(1);
      }      
            
      if(OrderDuration>0)
      {
      datetime FinTime = FinishTime(OrderDuration); 
      if (TimeCurrent()>=FinTime && ScanTrades(0,2) > 0) PendOrdDel(0); 
      }
      
      bool EOD = false;
      if(UseEODClose > 0)
      {
         if(DayOfWeek()!=5) datetime EndTime = StrToTime(SessionEnd+":00")-Period()*60; 
         else EndTime = StrToTime(FridayEnd+":00")-Period()*60;
         EOD = TimeCurrent()>= EndTime;
      }
      
      
      if ((UseNewSigClose>0 && TimeToOpen() && TimeCurrent()>=FinishTime(ProcessTime)) || EOD)
      {
         while (ScanTrades(0,1) > 0) CloseOrder(0);
         
         while (ScanTrades(0,2) > 0) PendOrdDel(0);
      }
            
      if (ScanTrades(0,1) > 0 && (TrailingStop>0 || BreakEven>0)) TrailStop();
   }
   
   if (ScanTrades(0,0)<OrdersNum)
   { 
      if(TimeToOpen() && TypeOrder>=0)
      {
         int OrdNum = OrdersNum - ScanTrades(0,0); 
         if (UseOpposite > 0) OrdNum = 0.5 * OrdersNum;         
         
         double sPoint = MarketInfo(Symbol(),MODE_POINT);
         
         if (TypeOrder == 0 || TypeOrder == 2 || TypeOrder == 4 )
         {   
            for(int cnt=1; cnt<=OrdNum; cnt++)
            {
            if (TypeOrder == 0) double BuyPrice = MarketInfo(Symbol(),MODE_ASK);
            else BuyPrice = OrderPrice;
		      
               if (UseExtSets > 0)
               {
                  if (OrderSL > 0) double BuyStop = OrderSL;
		            else BuyStop = 0; 
		            if (OrderTP > 0) double BuyProfit = OrderTP;
                  else BuyProfit = 0;
		         } 
		         else
		         {
		            if (StopLoss > 0) BuyStop =  BuyPrice - StopLoss*sPoint; 
		            else BuyStop=0;
                  if (TakeProfit  > 0) BuyProfit = BuyPrice + TakeProfit*sPoint; 
                  else BuyProfit=0;   
               }
             
            BuyOrdOpen(TypeOrder,BuyPrice,BuyStop,BuyProfit,cnt); 
            }
         }
         
         if (TypeOrder == 1 || TypeOrder == 3 || TypeOrder == 5 )
         {   
            for(cnt=1; cnt<=OrdNum; cnt++)
            {
            if (TypeOrder == 1) double SellPrice= MarketInfo(Symbol(),MODE_BID);
            else SellPrice = OrderPrice;
            
               if (UseExtSets > 0)
               {
                  if (OrderSL > 0) double SellStop = OrderSL;
		            else SellStop = 0; 
		            if (OrderTP > 0) double SellProfit = OrderTP;
                  else SellProfit = 0; 
		         }
		         else
		         {
                  if (StopLoss > 0) SellStop  = SellPrice + StopLoss*sPoint; 
                  else SellStop=0;
                  if (TakeProfit  > 0) SellProfit = SellPrice - TakeProfit*sPoint; 
                  else SellProfit=0;
               }                  
            
            SellOrdOpen(TypeOrder,SellPrice,SellStop,SellProfit,cnt);
            }
         }
      prevOpenTime = OpenTime;
      }
   }
      
 return(0);
}//int start
//+------------------------------------------------------------------+





